/***********************************************************************************************************************
 *
 * blueMarine Semantic - open source media workflow
 * Copyright (C) 2008-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~semantic-src
 *
 **********************************************************************************************************************/
package it.tidalwave.openrdf.elmo.impl;

import it.tidalwave.openrdf.elmo.impl.EntityBasedLookup;
import java.util.Set;
import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import org.openrdf.concepts.owl.Thing;

/*******************************************************************************
 *
 * FIXME: drop this, replaced by ElmoAs
 * 
 * @author  Fabrizio Giudici
 * @version $Id: OwlSameAsLazyLookup.java,v 4fbb06e9364c 2011/03/06 21:25:16 fabrizio $
 *
 ******************************************************************************/
public class OwlSameAsLazyLookup extends EntityBasedLookup<Thing>
  {
    /***************************************************************************
     *
     *
     **************************************************************************/
    public OwlSameAsLazyLookup (@Nonnull final Thing owner)
      {
        super(owner);
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Override
    @CheckForNull
    public <T> T lookup (@Nonnull final Class<T> clazz)
      {
        final Thing thing = getEntity();
        final Set<Thing> owlSameAs = thing.getOwlSameAs();
          System.err.println(String.format(">>>> lookup(%s) - %s - sameAs: %s", clazz, thing, owlSameAs));
        
        for (final Object sameAs : owlSameAs)
          {
            if (clazz.isAssignableFrom(sameAs.getClass()))
              {
                return (T)sameAs;
              }
          }

        return null;
      }
  }
