/***********************************************************************************************************************
 *
 * blueMarine Semantic - open source media workflow
 * Copyright (C) 2008-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~semantic-src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic;

import javax.annotation.CheckForNull;

/**
 *
 * @author fritz
 */
public abstract class LazyPropertyHolder<T>
  {
    @CheckForNull
    private T cached;

    private boolean resolved;

    @CheckForNull
    public final synchronized T get()
      {
        if (!resolved)
          {
            cached = create();
            resolved = true;
          }

        return cached;
      }

    @CheckForNull
    protected abstract T create();

    public synchronized void invalidate()
      {
        resolved = false;
        cached = null;
      }
  }
